'use client';
var jsxRuntime = require('react/jsx-runtime');
require('@mui/material/Button');
require('@mui/material/CircularProgress');
var react = require('react');
require('@mui/material/IconButton');
var iconsMaterial = require('@mui/icons-material');
var material = require('@mui/material');
var ButtonClient = require('./Button-client-BXpe6yJ-.js');
var IconButtonClient = require('./IconButton-client-ih4guhCY.js');
var DecorativeTitleClient = require('./DecorativeTitle-client-7Fz8mPtP.js');
var CardClient = require('./Card-client-BpzYE6Qn.js');
require('@mui/material/Backdrop');

/**
 * `Drawer` 抽屜元件，由螢幕邊緣滑出的浮動面版，
 * 常見的應用是作為導航用途，例如 Navigation drawers。
 *
 * 參考 [Material-UI Button](https://mui.com/material-ui/react-drawer/)
 */ const Drawer = /*#__PURE__*/ react.forwardRef(({ title, loading = false, loadingOptions, showCloseIcon = true, titleProps = {}, disableBackdropClick = false, contentProps = {}, actionsProps = {}, onClose: onCloseOuter, onSubmit, submitText = 'Submit', cancelText = 'Cancel', customActions, anchor = 'right', children, ...rest }, ref)=>{
    const [isSubmitting, setIsSubmitting] = react.useState(false);
    const handleCloseInter = (event, reason)=>{
        if (reason === 'backdropClick' && disableBackdropClick || isSubmitting) {
            return;
        }
        onCloseOuter?.(event, reason);
    };
    const handleCloseButtonClick = (event)=>{
        if (!isSubmitting) {
            onCloseOuter?.(event, 'closeButtonClick');
        }
    };
    const handleSubmit = async ()=>{
        setIsSubmitting(true);
        try {
            await onSubmit?.();
        } finally{
            setIsSubmitting(false);
        }
    };
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Drawer, {
        ref: ref,
        ...rest,
        anchor: anchor,
        onClose: handleCloseInter,
        PaperProps: {
            ...rest?.PaperProps,
            sx: {
                minWidth: {
                    xs: '100%',
                    md: '30%'
                },
                ...rest?.PaperProps?.sx
            }
        },
        children: [
            (title || showCloseIcon) && /*#__PURE__*/ jsxRuntime.jsxs(material.Box, {
                ...titleProps,
                sx: {
                    px: 3,
                    py: 2,
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'space-between',
                    ...titleProps?.sx
                },
                children: [
                    /*#__PURE__*/ jsxRuntime.jsx(DecorativeTitleClient.DecorativeTitle, {
                        sx: {
                            flex: 1
                        },
                        loading: loading,
                        children: title
                    }),
                    showCloseIcon && /*#__PURE__*/ jsxRuntime.jsx(IconButtonClient.IconButton, {
                        "aria-label": "drawer-close",
                        onClick: handleCloseButtonClick,
                        disabled: isSubmitting,
                        sx: {
                            color: 'text.secondary'
                        },
                        size: "small",
                        children: /*#__PURE__*/ jsxRuntime.jsx(iconsMaterial.Close, {})
                    })
                ]
            }),
            /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
                ...contentProps,
                sx: {
                    px: 3,
                    py: 2,
                    overflow: 'auto',
                    flexGrow: 1,
                    ...(contentProps?.dividers ?? true) && {
                        borderTop: 1,
                        borderBottom: 1,
                        borderColor: 'divider'
                    },
                    ...contentProps?.sx
                },
                children: loading ? /*#__PURE__*/ jsxRuntime.jsx(CardClient.LoadingContent, {
                    ...loadingOptions
                }) : children
            }),
            (onSubmit || customActions) && /*#__PURE__*/ jsxRuntime.jsx(material.Box, {
                ...actionsProps,
                sx: {
                    p: 1.5,
                    position: 'sticky',
                    bottom: 0,
                    display: 'flex',
                    alignItems: 'center',
                    justifyContent: 'center',
                    gap: 1.5,
                    ...actionsProps?.sx
                },
                children: customActions || /*#__PURE__*/ jsxRuntime.jsxs(jsxRuntime.Fragment, {
                    children: [
                        /*#__PURE__*/ jsxRuntime.jsx(ButtonClient.Button, {
                            variant: "outlined",
                            size: "medium",
                            onClick: handleCloseButtonClick,
                            disabled: isSubmitting,
                            children: cancelText
                        }),
                        /*#__PURE__*/ jsxRuntime.jsx(ButtonClient.Button, {
                            variant: "contained",
                            size: "medium",
                            onClick: handleSubmit,
                            loading: isSubmitting,
                            children: submitText
                        })
                    ]
                })
            })
        ]
    });
});
if (process.env.NODE_ENV !== 'production') {
    Drawer.displayName = 'GwDrawer';
}

exports.Drawer = Drawer;
