'use client';
var jsxRuntime = require('react/jsx-runtime');
var iconsMaterial = require('@mui/icons-material');
var material = require('@mui/material');
var react = require('react');
var ButtonClient = require('./Button-client-BXpe6yJ-.js');
var IconButtonClient = require('./IconButton-client-ih4guhCY.js');
var DecorativeTitleClient = require('./DecorativeTitle-client-7Fz8mPtP.js');
var CardClient = require('./Card-client-BpzYE6Qn.js');
require('@mui/material/Backdrop');
require('@mui/material/CircularProgress');

/**
 * `Modal` 是一個封裝好的對話框元件，提供了標題、內容、確定、取消等功能。
 *
 * 參考 [Material-UI Dialog](https://mui.com/material-ui/react-dialog/)
 */ const Modal = /*#__PURE__*/ react.forwardRef(({ title, loading = false, loadingOptions, showCloseIcon = true, titleProps = {}, disableBackdropClick = false, contentProps = {}, actionsProps = {}, onClose: onCloseOuter, onSubmit, submitButtonText = 'Submit', cancelButtonText = 'Cancel', customActions, children, ...rest }, ref)=>{
    const [isSubmitting, setIsSubmitting] = react.useState(false);
    const handleCloseInter = (event, reason)=>{
        if (reason === 'backdropClick' && disableBackdropClick || isSubmitting) {
            return;
        }
        onCloseOuter?.(event, reason);
    };
    const handleCloseButtonClick = (event)=>{
        if (!isSubmitting) {
            onCloseOuter?.(event, 'closeButtonClick');
        }
    };
    const handleSubmit = async ()=>{
        setIsSubmitting(true);
        try {
            await onSubmit?.();
        } finally{
            setIsSubmitting(false);
        }
    };
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Dialog, {
        ref: ref,
        ...rest,
        onClose: handleCloseInter,
        PaperProps: {
            ...rest?.PaperProps,
            sx: {
                borderRadius: 4,
                ...rest?.PaperProps?.sx
            }
        },
        children: [
            (title || showCloseIcon) && /*#__PURE__*/ jsxRuntime.jsxs(material.DialogTitle, {
                color: "primary.main",
                ...titleProps,
                sx: {
                    display: 'flex',
                    justifyContent: 'space-between',
                    alignItems: 'center',
                    ...titleProps?.sx
                },
                children: [
                    /*#__PURE__*/ jsxRuntime.jsx(DecorativeTitleClient.DecorativeTitle, {
                        sx: {
                            flex: 1
                        },
                        loading: loading,
                        children: title
                    }),
                    showCloseIcon && /*#__PURE__*/ jsxRuntime.jsx(IconButtonClient.IconButton, {
                        "aria-label": "modal-close",
                        onClick: handleCloseButtonClick,
                        disabled: isSubmitting,
                        sx: {
                            color: 'text.secondary'
                        },
                        size: "small",
                        children: /*#__PURE__*/ jsxRuntime.jsx(iconsMaterial.Close, {})
                    })
                ]
            }),
            /*#__PURE__*/ jsxRuntime.jsx(material.DialogContent, {
                ...contentProps,
                dividers: contentProps?.dividers ?? true,
                children: loading ? /*#__PURE__*/ jsxRuntime.jsx(CardClient.LoadingContent, {
                    ...loadingOptions
                }) : children
            }),
            (onSubmit || customActions) && /*#__PURE__*/ jsxRuntime.jsx(material.DialogActions, {
                ...actionsProps,
                sx: {
                    paddingX: 3,
                    paddingY: 2,
                    ...actionsProps?.sx
                },
                children: customActions || /*#__PURE__*/ jsxRuntime.jsxs(jsxRuntime.Fragment, {
                    children: [
                        /*#__PURE__*/ jsxRuntime.jsx(ButtonClient.Button, {
                            variant: "outlined",
                            size: "medium",
                            onClick: handleCloseButtonClick,
                            loading: loading,
                            disabled: isSubmitting,
                            sx: {
                                minWidth: 80
                            },
                            children: cancelButtonText
                        }),
                        /*#__PURE__*/ jsxRuntime.jsx(ButtonClient.Button, {
                            variant: "contained",
                            size: "medium",
                            onClick: handleSubmit,
                            loading: loading || isSubmitting,
                            sx: {
                                minWidth: 80
                            },
                            children: submitButtonText
                        })
                    ]
                })
            })
        ]
    });
});
if (process.env.NODE_ENV !== 'production') {
    Modal.displayName = 'GwModal';
}

exports.Modal = Modal;
