'use client';
var jsxRuntime = require('react/jsx-runtime');
var reactUtils = require('@gateweb/react-utils');
var material = require('@mui/material');
var react = require('react');
var useNumberIncrementClient = require('./useNumberIncrement-client-CXAoUzFN.js');

const NumberIncrement = ({ containerProps, textProps, formatValue = true, label, labelProps, ...props })=>{
    const currentValue = useNumberIncrementClient.useNumberIncrement(props);
    const value = react.useMemo(()=>{
        if (typeof formatValue === 'function') {
            return formatValue(currentValue);
        }
        return formatValue ? reactUtils.formatAmount(currentValue) : currentValue;
    }, [
        currentValue,
        formatValue
    ]);
    return /*#__PURE__*/ jsxRuntime.jsxs(material.Box, {
        textAlign: "center",
        ...containerProps,
        children: [
            /*#__PURE__*/ jsxRuntime.jsx(material.Typography, {
                variant: "h4",
                ...textProps,
                children: value
            }),
            label && /*#__PURE__*/ jsxRuntime.jsx(material.Typography, {
                variant: "body2",
                ...labelProps,
                children: label
            })
        ]
    });
};

exports.NumberIncrement = NumberIncrement;
