'use client';
import { jsxs, jsx } from 'react/jsx-runtime';
import { formatAmount } from '@gateweb/react-utils';
import { Box, Typography } from '@mui/material';
import { useMemo } from 'react';
import { u as useNumberIncrement } from './useNumberIncrement-client-CByAV4Yp.mjs';

const NumberIncrement = ({ containerProps, textProps, formatValue = true, label, labelProps, ...props })=>{
    const currentValue = useNumberIncrement(props);
    const value = useMemo(()=>{
        if (typeof formatValue === 'function') {
            return formatValue(currentValue);
        }
        return formatValue ? formatAmount(currentValue) : currentValue;
    }, [
        currentValue,
        formatValue
    ]);
    return /*#__PURE__*/ jsxs(Box, {
        textAlign: "center",
        ...containerProps,
        children: [
            /*#__PURE__*/ jsx(Typography, {
                variant: "h4",
                ...textProps,
                children: value
            }),
            label && /*#__PURE__*/ jsx(Typography, {
                variant: "body2",
                ...labelProps,
                children: label
            })
        ]
    });
};

export { NumberIncrement as N };
