'use client';
import { useState, useRef, useEffect } from 'react';

const useFileUpload = ({ files: outerFiles, onAddFile, onRemoveFile })=>{
    const [files, setFiles] = useState(outerFiles ?? []);
    const countRef = useRef(0);
    useEffect(()=>{
        setFiles(outerFiles ?? []);
    }, [
        outerFiles
    ]);
    const addFile = (newFile)=>{
        if (!newFile) return;
        const newFileInfo = {
            id: countRef.current,
            file: newFile
        };
        countRef.current += 1;
        const newFiles = [
            ...files,
            newFileInfo
        ];
        if (onAddFile) {
            onAddFile(newFileInfo, newFiles);
            return;
        }
        setFiles(newFiles);
    };
    const removeFile = (id)=>{
        if (onRemoveFile) {
            const targetFile = files.find((file)=>file.id === id);
            if (!targetFile) return;
            onRemoveFile(id, targetFile, files.filter((file)=>file.id !== id));
            return;
        }
        setFiles((preFiles)=>preFiles.filter((file)=>file.id !== id));
    };
    return {
        files,
        addFile,
        removeFile
    };
};

export { useFileUpload as u };
